<template>
  <div v-if="updating" class="updating-container">Updating...</div>
  <div v-if="!updating" class="flex-container">
    <div class="content-cell">
      <div v-if="ready">
        <FactViewContent
          :narrationTime="narrationTime"
          :segments="segments"
          :currentIndex="currentIndex"
          :playbackSpeed="playbackSpeed"
          :randomColor="meta.color"
          :kenBurns="meta.ken"
          :transitionAnimation="meta.transition"
          :logoElement="meta.logoImageElement"
        />
        <audio
          :src="currentAudioTrack"
          :playbackRate="playbackSpeed"
          @timeupdate="onTimeUpdate"
          autoplay
        />
      </div>

      <div v-else class="content-cell__pending">
        <img src="../assets/puzzle_globe_spinning.gif" />
      </div>
    </div>

    <div class="activity-cell">
      <h2>General</h2>
      <label for="ken-dropdown" class="effect-label">Ken Burns Effect:</label>
      <select id="ken-dropdown" v-model="meta.ken" class="effect-dropdown">
        <option value="ken">On</option>
        <option value="off">Off</option>
      </select>

      <label for="transition-dropdown" class="effect-label"
        >Transition Animation:</label
      >
      <select
        id="transition-dropdown"
        v-model="meta.transition"
        class="effect-dropdown"
      >
        <option value="ease">Ease</option>
        <option value="fade">Fade</option>
        <option value="push">Push</option>
      </select>

      <label for="color-dropdown" class="effect-label">Color:</label>
      <select id="color-dropdown" v-model="meta.color" class="effect-dropdown">
        <option v-for="color in brandColors" :key="color" :value="color">
          {{ color.charAt(0).toUpperCase() + color.slice(1) }}
        </option>
      </select>

      <label for="page-dropdown" class="effect-label">Page:</label>
      <select id="page-dropdown" v-model="page" class="effect-dropdown">
        <option value="one">One</option>
        <option value="two">Two</option>
        <option value="three">Three</option>
      </select>

      <template v-if="page === 'one'">
        <h2>Page One</h2>

        <label for="layout-1" class="effect-label">Layout:</label>
        <select
          id="layout-1"
          v-model="segments[0].layout"
          class="effect-dropdown"
        >
          <option value="standard">Standard</option>
          <option value="small">Small</option>
        </select>

        <label for="alignment-1" class="effect-label">Alignment:</label>
        <select
          id="alignment-1"
          v-model="segments[0].imageAlignment"
          class="effect-dropdown"
        >
          <option value="top left">Top Left</option>
          <option value="top center">Top Center</option>
          <option value="top right">Top Right</option>

          <option value="center left">Center Left</option>
          <option value="center center">Center Center</option>
          <option value="center right">Center Right</option>

          <option value="bottom left">Bottom Left</option>
          <option value="bottom center">Bottom Center</option>
          <option value="bottom right">Bottom Right</option>
        </select>

        <label for="caption-one" class="effect-label">Caption:</label>
        <textarea
          id="caption-one"
          v-if="segments[0]"
          v-model="segments[0].text"
          rows="6"
        />

        <label for="image-one" class="effect-label">Image:</label>
        <textarea
          id="image-one"
          v-if="segments[0]"
          v-model="segments[0].imageUrl"
          rows="6"
        />

        <label for="attribution-one" class="effect-label">Attribution:</label>
        <textarea
          id="attribution-one"
          v-if="segments[0]"
          v-model="segments[0].imageAttribution"
          rows="6"
        />
      </template>

      <template v-if="page === 'two'">
        <h2>Page Two</h2>

        <label for="layout-2" class="effect-label">Layout:</label>
        <select
          id="layout-2"
          v-model="segments[1].layout"
          class="effect-dropdown"
        >
          <option value="standard">Standard</option>
          <option value="small">Small</option>
        </select>

        <label for="alignment-2" class="effect-label">Alignment:</label>
        <select
          id="alignment-2"
          v-model="segments[1].imageAlignment"
          class="effect-dropdown"
        >
          <option value="top left">Top Left</option>
          <option value="top center">Top Center</option>
          <option value="top right">Top Right</option>

          <option value="center left">Center Left</option>
          <option value="center center">Center Center</option>
          <option value="center right">Center Right</option>

          <option value="bottom left">Bottom Left</option>
          <option value="bottom center">Bottom Center</option>
          <option value="bottom right">Bottom Right</option>
        </select>

        <label for="caption-two" class="effect-label">Caption:</label>
        <textarea
          id="caption-two"
          v-if="segments[1]"
          v-model="segments[1].text"
          rows="6"
        />

        <label for="image-two" class="effect-label">Image:</label>
        <textarea
          id="image-two"
          v-if="segments[1]"
          v-model="segments[1].imageUrl"
          rows="6"
        />

        <label for="attribution-two" class="effect-label">Attribution:</label>
        <textarea
          id="attribution-two"
          v-if="segments[1]"
          v-model="segments[1].imageAttribution"
          rows="6"
        />
      </template>

      <template v-if="page === 'three'">
        <h2>Page Three</h2>

        <label for="layout-3" class="effect-label">Layout:</label>
        <select
          id="layout-3"
          v-model="segments[2].layout"
          class="effect-dropdown"
        >
          <option value="standard">Standard</option>
          <option value="small">Small</option>
        </select>

        <label for="alignment-3" class="effect-label">Alignment:</label>
        <select
          id="alignment-3"
          v-model="segments[2].imageAlignment"
          class="effect-dropdown"
        >
          <option value="top left">Top Left</option>
          <option value="top center">Top Center</option>
          <option value="top right">Top Right</option>

          <option value="center left">Center Left</option>
          <option value="center center">Center Center</option>
          <option value="center right">Center Right</option>

          <option value="bottom left">Bottom Left</option>
          <option value="bottom center">Bottom Center</option>
          <option value="bottom right">Bottom Right</option>
        </select>

        <label for="caption-three" class="effect-label">Caption:</label>
        <textarea
          id="caption-three"
          v-if="segments[2]"
          v-model="segments[2].text"
          rows="6"
        />

        <label for="image-three" class="effect-label">Image:</label>
        <textarea
          id="image-three"
          v-if="segments[2]"
          v-model="segments[2].imageUrl"
          rows="6"
        />

        <label for="attribution-three" class="effect-label">Attribution:</label>
        <textarea
          id="attribution-three"
          v-if="segments[2]"
          v-model="segments[2].imageAttribution"
          rows="6"
        />
      </template>

      <h2>Actions</h2>

      <div class="activity-buttons">
        <button v-if="id >= 0 && id < 200" @click="reroll">Re-Roll</button>
        <button @click="reload" v-if="done">Reload</button>
        <button @click="save">Save</button>
        <button @click="download" v-if="!recording">Download</button>
        <button @click="exit" v-if="!recording">Exit</button>
      </div>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { ref, watch, computed, inject, onMounted, onUnmounted } from 'vue';
import { useRouter } from 'vue-router';
import { CdxButton, CdxIcon } from '@wikimedia/codex';
import {
  cdxIconClose,
  cdxIconDownload,
  cdxIconEdit,
  cdxIconReload,
  cdxIconFunction,
} from '@wikimedia/codex-icons';
import { FactSegmentData, MetaData } from '../types';
import { brandColors } from '../../shared/colorUtils';
import FactViewContent from './FactViewContent.vue';
import wBlackUrl from '../assets/w_black.png';
import wWhiteUrl from '../assets/w_white.png';

declare global {
  interface Window {
    WikiTok: any;
  }
}

window.WikiTok = {
  ready: false,
  done: false,
};

const props = defineProps({
  id: { type: Number, required: true },
});

const router = useRouter();

// Background music
const narrationTime = ref(0);

// Video segments and spoken text

let timer: ReturnType<typeof setInterval>;

/**
 * Whether the API request is complete or not
 */
const ready = ref(false);

/**
 * Whether we are running in a recording environment or not
 */
const recording = ref(false);

/**
 * Whether the sequence has finished
 */
const done = ref(false);

/**
 * Playback speed for the video (for recording)
 */
const playbackSpeed = ref(1);

/**
 * API data for each video segment
 */
const segments = ref<FactSegmentData[]>([]);

/**
 * API data for video meta settings
 */
const meta = ref<MetaData>({
  color: 'white',
  ken: 'ken',
  transition: 'ease',
});

const page = ref('one');

/**
 * The total remaining time for the video. This value will continuously
 * decrease once the video begins, until it hits zero.
 */
const remainingTime = ref(0);

/**
 * Pointer to the currently active segment, based on amount of elapsed time.
 */
const currentIndex = ref(0);

/**
 * Track whether the page is being updated
 */
const updating = ref(false);

/**
 * Current audio track, based on the currently active segment.
 */
const currentAudioTrack = computed(() => {
  return '/static' + segments.value[currentIndex.value].speechFileUrl;
});

/**
 * Total duration is the sum of the durations of all segments.
 */
const totalDuration = computed(() => {
  return Number(
    segments.value
      .map((s) => s.speechFileDuration)
      .reduce((curr, acc) => {
        return Number(curr) + Number(acc);
      }, 0)
  );
});

/**
 * Get the start time of an arbitrary segment, expressed as a numerical value
 * below the total duration in fractions of a second. Once the timer drops below
 * this point, the segment in question should be shown.
 *
 * @param {number} index Index of the segment in question
 * @return {number}
 */
function getSegmentStartTime(index: number): number {
  const previousSegments = segments.value.filter((s, i) => i < index);
  const durationOfPreviousSegments = previousSegments
    .map((s) => s.speechFileDuration)
    .reduce((curr, acc) => curr + acc, 0);
  return totalDuration.value - durationOfPreviousSegments;
}

/**
 * Get the end time of an arbitrary segment, expressed as a numerical value
 * below the total duration in fractions of a second. Once the timer drops
 * below this value, the segment AFTER this one (if any) should be shown.
 *
 * @param {number} index
 * @return {number}
 */
function getSegmentEndTime(index: number): number {
  return getSegmentStartTime(index) - segments.value[index].speechFileDuration;
}

/**
 * Get the segment data for the desired "fact"
 *
 * @param {number} id
 */
async function getData(id: number, reroll: boolean = false) {
  const response = await fetch(`/dyk?factId=${props.id}&reroll=${reroll}`);
  const data = await response.json();
  if ('meta' in data) {
    meta.value = data.meta;
  }

  if ('segments' in data && Array.isArray(data.segments)) {
    data.segments.forEach((segment: FactSegmentData) => {
      if (!('layout' in segment)) {
        (segment as FactSegmentData).layout = 'standard';
      }

      console.log(segment);

      if (!('imageAlignment' in segment)) {
        (segment as FactSegmentData).imageAlignment = 'center center';
      }

      segments.value.push(segment);
    });

    // hackily add the end card
    segments.value.push({
      layout: 'standard',
      imageUrl: '',
      title: '',
      text: '',
      imageAttribution: '',
      imageAlignment: 'center center',
      speechFileUrl: '',
      speechFileDuration: 6,
    });

    // now we wait for image data to be loaded
    const images = data.segments.map((segment: FactSegmentData) => {
      const img = new Image();
      img.src = segment.imageUrl;
      segment.imageElement = img;
      return img.decode();
    });
    await Promise.allSettled(images);

    const img = new Image();
    if (meta.value.color == 'white') {
      img.src = wBlackUrl;
    } else {
      img.src = wWhiteUrl;
    }
    img.style.width = '88px';
    meta.value.logoImageElement = img;
    await img.decode();

    // now we wait for audio data to be loaded
    const audios = data.segments.map((segment: FactSegmentData) => {
      const audio = new Audio();
      audio.src = segment.speechFileUrl;
      return audio.load();
    });
    await Promise.allSettled(audios);

    // based on the query parameter, we can determine if we are in a recording environment
    const urlParams = new URLSearchParams(window.location.search);
    recording.value = urlParams.get('render') === 'true';
    playbackSpeed.value = urlParams.get('speed')
      ? Number(urlParams.get('speed'))
      : 1;

    ready.value = true;

    setTimeout(() => {
      // short extra delay for the recording environment to catch up
      window.WikiTok['ready'] = true;
    }, 50);
  }
}

/**
 * When the data is ready, set up the timer based on
 * the total duration of the returned segments.
 */
watch(ready, (newVal) => {
  if (newVal) {
    remainingTime.value = totalDuration.value;

    timer = setInterval(
      () => {
        remainingTime.value -= 0.1;
      },
      100 * (1 / playbackSpeed.value)
    );
  }
});

/**
 * Handle the passage of time:
 * - when the remaining time drops below the "start" value for
 *   the current section, show the next section (if any)
 * - when the remaining time drops to or below zero, stop
 *   the countdown
 */
watch(remainingTime, (newVal) => {
  if (newVal <= 0) {
    remainingTime.value = totalDuration.value;
    if (!recording.value) {
      done.value = true;
    }
    window.WikiTok['done'] = true;
    return;
  }

  if (newVal <= getSegmentEndTime(currentIndex.value)) {
    currentIndex.value++;
  }
});

function download() {
  // open a new tab at the download URL
  const downloadUrl = `/record?factId=${props.id}`;
  window.open(downloadUrl, '_blank');
}

async function save() {
  updating.value = true;

  // Make a POST request to /edit with segments as transcriptEdit
  try {
    const response = await fetch(`/edit?factId=${props.id}`, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
      },
      body: JSON.stringify({
        transcriptEdit: segments.value.slice(0, 3),
        meta: meta.value,
      }),
    });

    if (!response.ok) {
      updating.value = false;
      throw new Error('Network response was not ok');
    }

    window.location.reload();
  } catch (error) {
    updating.value = false;

    console.error('Error saving data:', error);
  }
}

function reload() {
  done.value = false;
  currentIndex.value = 0;
  clearInterval(timer);
  remainingTime.value = 0;
}

function reroll() {
  ready.value = false;
  segments.value = [];
  reload();
  getData(props.id, true);
}

function exit() {
  router.push(`/#fact-${props.id}`);
}

function onEscape(event: KeyboardEvent) {
  if (event.key === 'Escape') {
    exit();
  }
}

function onTimeUpdate(event: Event) {
  const audio = event.target as HTMLAudioElement;
  narrationTime.value = audio.currentTime;
}

onMounted(() => {
  document.addEventListener('keyup', onEscape);

  // Set the scale of .flex-container based on screen density
  // const flexContainer = document.querySelector(
  //   '.flex-container'
  // ) as HTMLElement;
  // if (flexContainer) {
  //   const scale = window.devicePixelRatio;
  //   flexContainer.style.transform = `scale(${scale})`;
  // }
});

onUnmounted(() => {
  document.removeEventListener('keyup', onEscape);
});

getData(props.id);
</script>

<style lang="less">
textarea {
  resize: none;
}

.updating-container {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh; /* Full viewport height */
  font-size: 24px; /* Adjust the font size as needed */
}

.flex-container {
  display: flex;
  width: 100%;
  height: 1920px;
}

.content-cell {
  aspect-ratio: 9 / 16;
  height: 1920px;
  width: auto;
  flex-shrink: 0;
  overflow: hidden;
  position: relative;

  &__pending {
    padding: 4rem;

    img {
      max-width: 100%;
      height: auto;
    }
  }
}

.activity-cell {
  display: flex;
  flex-direction: column;
  padding: 1rem;
  gap: 1rem;
}

.activity-buttons {
  align-self: start;
  display: flex;
  flex-direction: column;
  gap: 1rem;
}
</style>
